PROMPT
PROMPT Starting downgrade for Incremental Summations
PROMPT

SET SERVEROUTPUT ON SIZE 1000000

PROMPT Drop all DXS and DXC tables (if needed)
PROMPT ...this may take a few minutes...
PROMPT
-- For each DXS and DXC table, issue a DROP

DECLARE
   l_sql VARCHAR2(1000);
   l_table_id INTEGER;
   l_xs_tablename VARCHAR2(32);
   l_xc_tablename VARCHAR2(32);
   l_dropped_table INTEGER := 0;
BEGIN

   FOR i IN ( SELECT table_name
              FROM user_tables
              WHERE SUBSTR(table_name,-4) in ('_DXS', '_DXC')
              ORDER BY table_name ) LOOP

      SELECT summarize.GenDestName( i.table_name, 'XS'), 
             summarize.GenDestName( i.table_name, 'XC')
        INTO l_xs_tablename, l_xc_tablename
        FROM DUAL;
        
      -- If tablenames are the same, then old summarize code is installed
      -- so drop the tables  
      IF (l_xs_tablename = l_xc_tablename) THEN
      
         -- Remove part_tables entries, trigger will clean subclass_map
         SELECT part_table_id INTO l_table_id
           FROM part_tables
          WHERE table_name = i.table_name;

         DELETE FROM part_tables
          WHERE part_table_id = l_table_id;

         DBMS_OUTPUT.PUT_LINE(i.table_name);
         l_sql := 'DROP TABLE ' || i.table_name;

         -- This forces a COMMIT
         EXECUTE IMMEDIATE l_sql;
         
         l_dropped_table := 1;
      END IF;
   END LOOP;
   
   IF (l_dropped_table = 1) THEN
      wm_sysval.deleteSysVal( 'SummationLastNIDate' );
      wm_sysval.deletesysval( 'SummationForceNI' );
      COMMIT;
   END IF;
END;
/

PROMPT
PROMPT Downgrade Complete
PROMPT

